freeslot("sfx_monrsp")
sfxinfo[sfx_monrsp].caption = "Item respawned"

local itemtable_weak = {}
local itemtable_strong = {}
local setweight = function(mobjtype, weight_weak, weight_strong)
	for i = 0, weight_weak
		table.insert(itemtable_weak, mobjtype)
	end
	for i = 0, weight_strong
		table.insert(itemtable_strong, mobjtype)
	end
end

local sparkles = function(mo, size)
	for i = 0, 8
		local sparkle = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_BOXSPARKLE)
		P_InstaThrust(sparkle, i * ANGLE_45, size*mo.scale)
	end
end

local respawn = function(mo, rollrandom)
	local newmo
	if rollrandom
		local randombox
		if rollrandom == 2
			randombox = itemtable_strong[P_RandomRange(1, #itemtable_strong - 1)]
		else
			randombox = itemtable_weak[P_RandomRange(1, #itemtable_weak - 1)]
		end
		newmo = P_SpawnMobj(mo.x, mo.y, mo.z, randombox)
	else
		newmo = P_SpawnMobj(mo.x, mo.y, mo.z, mo.type)
	end
	newmo.flags2 = mo.flags2
	S_StartSound(newmo, sfx_monrsp)
	sparkles(newmo, 3)
end

local respawntimer = function(mo)
	if mo.info.speed == 0
		return
	end
	local f = mo.fuse - 2
	if (f == TICRATE) or (f == 2*TICRATE) or (f == 3*TICRATE)
		S_StartSoundAtVolume(mo, sfx_s3kcas, 60)
		sparkles(mo, 1)
	end
	if (f == 0)
		if (mo.flags2 & MF2_STRONGBOX)
			respawn(mo, 2)
		elseif (mo.flags2 & MF2_AMBUSH)
			respawn(mo, 1)
		else
			respawn(mo, 0)
		end
		P_RemoveMobj(mo)
	end
end

//Shields
setweight(MT_WHIRLWIND_BOX,		60, 0)
setweight(MT_ELEMENTAL_BOX,		0,  60)
setweight(MT_ATTRACT_BOX,		0,  60)
setweight(MT_FORCE_BOX,			60, 0)
setweight(MT_ARMAGEDDON_BOX,	0,  60)
setweight(MT_THUNDERCOIN_BOX,	30, 30)
setweight(MT_BUBBLEWRAP_BOX,	60, 0)
setweight(MT_FLAMEAURA_BOX,		30, 30)

//Misc
setweight(MT_SNEAKERS_BOX,		10, 0)
setweight(MT_INVULN_BOX,		0,  30)
setweight(MT_1UP_BOX,			0,  30)
setweight(MT_RECYCLER_BOX,		10, 0)
setweight(MT_MIXUP_BOX,			5,  0)

for i = MT_RING_BOX, MT_THUNDERCOIN_BOX
	addHook("MobjThinker", respawntimer, i)
end
addHook("MobjThinker", respawntimer, MT_RING_REDBOX)
addHook("MobjThinker", respawntimer, MT_RING_BLUEBOX)